<template>
  <div>
    <Loading v-if="loading" />
    <div v-if="!loading && !error">
      <div v-if="!loading">
        <AccessRequestDetailsVue
          v-if="accessRequestDisplay"
          :access-request="accessRequestDisplay"
        />
        <hr />
        <AccessRequestEvaluationDetailsVue
          v-if="accessRequestDisplay"
          :access-request="accessRequestDisplay"
        />
        <div class="card form-container">
          <div v-if="!loading">
            <div v-if="showForm">
              <div v-if="evaluationType === 'am' && forms.am">
                <h3>
                  Access Manager evaluation for dataset
                  {{
                    accessRequest.datasets.find((dataset) => dataset.is_main)
                      .dataset.label
                  }}
                </h3>
                <table>
                  <tr v-for="input in forms.am" :key="input.form_name">
                    <td class="question-column">{{ input.label }}</td>
                    <td>
                      <select
                        v-model="accessRequest[input.form_name]"
                        class="form-control"
                      >
                        <option
                          v-for="option in input.options"
                          :key="option"
                          :value="option"
                        >
                          {{ option }}
                        </option>
                      </select>
                    </td>
                  </tr>
                </table>
                <table>
                  <tr>
                    <td class="question-column">Reasoning</td>
                    <td>
                      <textarea
                        v-model="accessRequest.reasoning_am"
                        cols="50"
                        rows="3"
                        class="form-control"
                      >
                      </textarea>
                    </td>
                  </tr>
                </table>
                <b-button @click="submitAm()">Submit</b-button>
              </div>
              <div v-if="evaluationType === 'sam' && forms.sam">
                <h3>Secondary access manager evaluation</h3>
                <table width="80%">
                  <tr>
                    <th width="25%">Dataset</th>
                    <th width="25%">Decision</th>
                    <th width="50%">Reasoning</th>
                  </tr>
                  <tr v-for="dataset in secondaryAmDatasets" :key="dataset.id">
                    <td>{{ dataset.dataset.label }}</td>
                    <td>
                      <select
                        v-model="dataset.decision"
                        class="form-control col-8"
                      >
                        <option value="1">Positive</option>
                        <option value="0">Negative</option>
                      </select>
                    </td>
                    <td>
                      <textarea
                        v-model="dataset.description"
                        class="form-control"
                        cols="50"
                        rows="2"
                      ></textarea>
                    </td>
                  </tr>
                </table>

                <b-button @click="submitSAM()">Submit</b-button>
              </div>
              <div v-if="evaluationType === 'pc' && forms.pc">
                <h3>Project Coordinator evaluation</h3>
                <table>
                  <tr v-for="input in forms.pc" :key="input.form_name">
                    <td class="question-column">{{ input.label }}</td>
                    <td>
                      <select
                        v-model="accessRequest[input.form_name]"
                        class="form-control"
                      >
                        <option
                          v-for="option in input.options"
                          :key="option"
                          :value="option"
                        >
                          {{ option }}
                        </option>
                      </select>
                    </td>
                  </tr>
                </table>
                <b-button @click="submitPC()">Submit</b-button>
              </div>
              <span v-if="formError">{{ formError }}</span>
            </div>
            <div v-if="message" class="message">
              <AlertTriangleIcon />
              {{ message }}
            </div>
          </div>
        </div>
      </div>
    </div>
    <div v-if="!loading && error">
      <Error :error="error" />
    </div>
  </div>
</template>
<script>
import AccessRequestDetailsVue from '~/components/AccessRequestDetails.vue';
import AccessRequestEvaluationDetailsVue from '~/components/AccessRequestEvaluationDetails.vue';
import Loading from '~/components/Loading.vue';

export default {
  components: {
    AccessRequestDetailsVue,
    AccessRequestEvaluationDetailsVue,
    Loading,
  },
  layout: 'dashboard',
  middleware: 'auth',
  data() {
    return {
      loading: true,
      formError: null,
      showForm: false,
      accessRequest: null,
      accessRequestDisplay: null,
      evaluationType: null,
      secondaryAmDatasets: [],
      error: false,
      message: '',
      options: ['High', 'Medium', 'Low'],
      decision: {
        form_name: 'decision',
        value: null,
        label: 'Decision',
        options: ['Positive', 'Negative'],
      },
      forms: {},
      formData: {
        access_request_id: this.$nuxt.$route.params.id,
        type: this.evaluationType,
        accessRequest: null,
      },
      reasoning: {
        amReasoning: '',
        samReasoning: '',
      },
    };
  },
  async fetch() {
    try {
      const evaluation = await this.$nuxt.context.store.dispatch(
        'access_request/evaluationDetails',
        this.$nuxt.$route.params.id
      );
      this.accessRequest = evaluation.accessRequest;
      this.accessRequestDisplay = Object.assign({}, evaluation.accessRequest);
      this.evaluationType = evaluation.evaluationType;
      this.secondaryAmDatasets = evaluation.secondaryDatasets;
      this.showForm = evaluation.showForm;
      this.message = evaluation.message;
      this.loading = false;
    } catch (e) {
      this.error = { statusCode: 404 };
      this.loading = false;
    }
  },
  head() {
    return {
      title: 'Access Request Evaluation - RISIS Workspace',
    };
  },
  mounted() {
    this.loading = false;
  },
  beforeMount() {
    this.forms = {
      am: [
        {
          form_name: 'first_question_am',
          value: null,
          label: 'Is the proposed research new and original?',
          options: this.options,
        },
        {
          form_name: 'second_question_am',
          value: null,
          label: 'Is the proposed research scientifically relevant?',
          options: this.options,
        },
        {
          form_name: 'third_question_am',
          value: null,
          label: 'Is the proposed research relevant in a policy context?',
          options: this.options,
        },
        {
          form_name: 'forth_question_am',
          value: null,
          label:
            'Is the proposal clear (in terms of scientifically objectives and requested data)?',
          options: this.options,
        },
        this.getDecisionInput('am'),
      ],
      sam: [],
      pc: [this.getDecisionInput('pc')],
    };
  },
  methods: {
    getDecisionInput(level) {
      const decision = JSON.parse(JSON.stringify(this.decision));
      if (level === 'am') {
        decision.options.push('Revise');
      }
      decision.form_name = decision.form_name + '_' + level;
      return decision;
    },
    submitAm() {
      this.submitEvaluation(this.accessRequest);
    },
    submitSAM() {
      this.submitEvaluation(this.secondaryAmDatasets);
    },
    submitPC() {
      this.submitEvaluation(this.accessRequest);
    },
    // eslint-disable-next-line require-await
    async submitEvaluation(formData) {
      const ar = formData;
      let valid = true;
      this.formError = null;
      await this.forms[this.evaluationType].forEach((field) => {
        if (!ar[field.form_name] || ar[field.form_name] === '') {
          valid = false;
        }
      });
      if (!valid) {
        this.formError = 'Please fill all the fields';
        return;
      }
      try {
        this.accessRequests = await this.$nuxt.context.store.dispatch(
          'access_request/submitEvaluation',
          {
            accessRequest: formData,
            id: this.accessRequest.id,
            type: this.evaluationType,
          }
        );
        window.location.href = `/access-request/${this.accessRequest.id}/details`;
      } catch (e) {
        await this.$bvModal.msgBoxConfirm(
          'There was an error submitting the evaluation, please try again'
        );
      }
    },
  },
};
</script>

<style scoped>
.question-column {
  width: 400px;
}

.message {
  padding: 10px;
  background-color: #ffc150;
  border-radius: 5px;
  margin-bottom: 5px;
}

.form-container {
  padding: 15px;
}
</style>
